//
//      SAXParser.cpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.5
//

#include "SAXParser.hpp"
#include "pself2.hpp"

// RXgN^
SAXParser::SAXParser(Void) : _isParseItemAttributes(true), _isParseImageUrl(false), _isParseOfferSummary(false),
    _isParseOffers(false), _isParseCustomerReviews(false), _isParseSimilarProducts(false), _isParseBrowserNodes(false),
    _isParseListmaniaLists(false), _itemAttributes(null), _imageUrl(null), _offerSummary(null), _offers(null),
    _customerReviews(null), _similarProducts(null), _browserNodes(null),_listmaniaLists(null), _itemflg(false),
	_kind(NOTHING), _packageDimensionsflg(false), _similarProductflg(false), _itemAttributesflg(false),_characterGetflg(false),_xmlerrorflg(false)
{

	 return;
}

// fXgN^
SAXParser::~SAXParser(Void)
{
	Clear();
	return;
}

// 
Void SAXParser::Clear(Void)
{
	// ^Cg̃NA
    _title.Clear();
	// ISBN ̃NA
    _asin.Clear();

	// _itemAttributes \̂̍폜
	::delete _itemAttributes;
    _itemAttributes = null;

	// _itemAttributes \̂̍폜
    ::delete _imageUrl;
    _imageUrl = null;

	// _offerSummary \̂̍폜
    ::delete _offerSummary;
    _offerSummary = null;
    if (_offers != null) {
		// _offers \̂̍폜
        SFXArray<OfferRecPtr>::Enumerator enumerator = _offers->offers.GetFirstEnumerator();
        while (enumerator.HasNext()) {
            OfferRecPtr offer(enumerator.GetNext());
            delete offer;
        }
        _offers->offers.Clear();
        delete _offers;
        _offers = null;
    }
    
	// _customerReviews ̍폜
    if (_customerReviews != null) {
        SFXArray<ReviewRecPtr>::Enumerator enumerator = _customerReviews->reviews.GetFirstEnumerator();
        while (enumerator.HasNext()) {
            ReviewRecPtr review(enumerator.GetNext());
            delete review;
        }
        _customerReviews->reviews.Clear();
        delete _customerReviews;
        _customerReviews = null;
    }

	// _similarProducts ̍폜
    if (_similarProducts != null) {
        SFXArray<SimilarProductRecPtr>::Enumerator enumerator = _similarProducts->similarProducts.GetFirstEnumerator();
        while (enumerator.HasNext()) {
            SimilarProductRecPtr similarProduct(enumerator.GetNext());
            delete similarProduct;
        }
        _similarProducts->similarProducts.Clear();
        delete _similarProducts;
        _similarProducts = null;
    }
}

// f[^̒ʒm󂯎nh
Void SAXParser::Characters(SFXAnsiStringConstRef string, BoolConst /*cdataSection*/)
{
	if(_characterGetflg)
		// f[^擾
		_characters.Set(string.Replace("&lt;", '<').Replace("&gt;", '>').Replace("&quot;", '"').Replace("&amp;", '&'));
}

// ̊Jnʒm󂯎nh
Void SAXParser::StartDocument(Void)
{
	// ItemAttributes͂ꍇ
	if (_isParseItemAttributes) { 	
		_itemAttributes = new ItemAttributesRec;
		_itemAttributes->numberOfPages = 0;
		_itemAttributes->packageDimensionsLength = 0;
		_itemAttributes->packageDimensionsWidth = 0;
	}

	// ImageUrl͂ꍇ
	if(_isParseImageUrl){
		_imageUrl = new ImageUrlRec;
	}

	if(_isParseSimilarProducts){
		_similarProducts = new SimilarProductsRec;
	}

	if(_isParseCustomerReviews){
		_customerReviews = new CustomerReviewsRec;
	}
}

// ̏Iʒm󂯎nh
Void SAXParser::EndDocument(Void)
{
}

// vf̊Jnʒm󂯎nh
Void SAXParser::StartElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname, SFXXMLGrammar::XMLAttrListConstRef attrList)
{

	// NGXgԂĂĂ邩
	if(qname == "Errors")
		_xmlerrorflg = true;

	// f[^擾邩ǂ
	if(qname == START_NODENAME)
		_characterGetflg = true;

	// vf Item Ȃ
	if(qname == "Item"){
		_itemflg = true;
	}
	// vf ItemAttributes Ȃ
	else if (qname == "ItemAttributes") {
		if (_isParseItemAttributes) { 	
			_itemAttributesflg = true;
		}
	// vf SmallImage Ȃ
	}else if (qname == "SmallImage") {
		if(_isParseImageUrl){
			_kind =SMALL;
		}
	// vf MediumImage Ȃ
	}else if (qname == "MediumImage") {
		if(_isParseImageUrl){
			_kind =MEDIUM;
		}
	// vf LargeImage Ȃ
	}else if (qname == "LargeImage") {
		if(_isParseImageUrl){
			_kind =LARGE;
		}
	// vf Review Ȃ
	}else if (qname == "Review") {
		 _review = new ReviewRec;
	}
	// vf SimilarProduct Ȃ
	else if(qname == "SimilarProduct"){
		_similarProduct = new SimilarProductRec;
		_similarProductflg = true;
	}
	// vf PackageDimensions Ȃ
	else if(qname == "PackageDimensions"){
		_packageDimensionsflg = true;
	}

	// vf Creator Ȃ
	if (qname == "Creator") {
		SFXXMLGrammar::XMLAttrList::Enumerator iter = attrList.GetFirstEnumerator();
		while (iter.HasNext()) {
			SFXXMLGrammar::LPXMLATTR attr = iter.GetNext();
			_values = attr->_value;
			
		} 
	}
	
}

// vf̏Iʒm󂯎nh
Void SAXParser::EndElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname)
{

	// f[^擾邩ǂ
	if(qname == END_NODENAME)
		_characterGetflg = false;

	// vf ASIN ̏ꍇ
	if(qname == "ASIN") {   
		// 擾   
		if(_itemflg){
			// 擾   
			_asin =_characters;
			_itemflg = false;
		}
		// vf SimilarProduct ̏ꍇ  
		if(_similarProductflg){
			_similarProduct->asin = _characters;
		}	  
	} 
	// vf DetailPageURL ̏ꍇ  
	else if (qname == "DetailPageURL") {
		// 擾   
		_detailPageURL = _characters;
	    
	}
	// vf SalesRank ̏ꍇ  
	else if (qname == "SalesRank") {
		// 擾                
		// SalesRankɂ̓J}Ă̂ō폜    
		_salesRank = _characters.Replace(',', "").AsSInt32(0);
	}
	// vf Binding ̏ꍇ
	else if (qname == "Binding") {
		// 擾  
		_itemAttributes->binding =  _characters;   
	}
	// vf Creator ̏ꍇ
	else if (qname == "Creator") {
		// L[Ɋ֘Atꂽl𖖔ɒǉ	
		_itemAttributes->creator.Append(_values, _characters);   
	}
	// vf Amount ̏ꍇ      
	else if (qname == "Amount") {
		// 擾  
		_itemAttributes->amount = _characters.AsSInt32(0);  
	}
	// vf CurrencyCode ̏ꍇ
	else if (qname == "CurrencyCode") {
		// 擾  
		_itemAttributes->currencyCode = _characters;
	}
	// vf FormattedPrice ̏ꍇ   
	else if (qname == "FormattedPrice") {
		// 擾    	
		_itemAttributes->formattedPrice = _characters;
	}
	// vf NumberOfPages ̏ꍇ
	else if (qname == "NumberOfPages") {
		_itemAttributes->numberOfPages =_characters.AsSInt32(0);   
	}
	// vf Length ̏ꍇ   
	else if (qname == "Length") {
		// PackageDimensions m[h Length ̏ꍇ
		if(_itemAttributesflg)
			_itemAttributes->packageDimensionsLength = _characters.AsSInt32(0);   
	// vf Width ̏ꍇ   
	}else if (qname == "Width") {	
		// PackageDimensions m[h Width ̏ꍇ
		if(_packageDimensionsflg)
			// 擾   
			_itemAttributes->packageDimensionsWidth =_characters.AsSInt32(0);   
		if(_isParseImageUrl)
			switch(_kind){
			case SMALL:
				// 擾 
				_imageUrl->smallImageWidth = _characters.AsSInt32(0);             
				break;
			case MEDIUM:
				// 擾 
				_imageUrl->mediumImageWidth = _characters.AsSInt32(0); 
				break;
			case LARGE:
				// 擾 
				_imageUrl->largeImageWidth = _characters.AsSInt32(0); 
				break;
		}
	// vf ProductGroup ̏ꍇ   
	}else if (qname == "ProductGroup") {
		// 擾 
		_itemAttributes->productGroup = _characters;
	// vf PublicationDate ̏ꍇ
	}else if (qname == "PublicationDate") {
		_itemAttributes->publicationDate  = StringToDate(_characters);   
	// vf Publisher ̏ꍇ
	}else if (qname == "Publisher") {
		// 擾 
		_itemAttributes->publisher = _characters;
	// vf Title ̏ꍇ
	}else if (localname == "Title") {
		if(_itemAttributesflg){
			// 擾 
			_title = _characters;
			_itemAttributesflg = false;
		}else if(_similarProductflg){
			// 擾 
			_similarProduct->title = _characters;
			_similarProducts->similarProducts.Append(_similarProduct);
		}
	}
	// vf URL ̏ꍇ
	else if (qname == "URL") {
		switch(_kind){
			case SMALL:
				// 擾 
                _imageUrl->smallImageURL = _characters;   
				break;
			case MEDIUM:
				// 擾 
				_imageUrl->mediumImageURL = _characters;
				break;
			case LARGE:
				// 擾 
				_imageUrl->largeImageURL = _characters;
				break;
		}
	// vf Height ̏ꍇ
 	}else if (qname == "Height") {
		switch(_kind){
			case SMALL:
				// 擾 
				_imageUrl->smallImageHeight = _characters.AsSInt32(0);
				break;
			case MEDIUM:
				// 擾 
				_imageUrl->mediumImageHeight = _characters.AsSInt32(0);
				break;
			case LARGE:
				// 擾 
				_imageUrl->largeImageHeight = _characters.AsSInt32(0);
				break;
		}
	// vf AverageRating ̏ꍇ
	}else if (qname == "AverageRating") {
		// m[h擾 
        _customerReviews->avarageRating = _characters.AsSInt32(0); 
	// vf TotalReviews ̏ꍇ
	}else if (qname == "TotalReviews") {
		// 擾 
		_customerReviews->totalReviews = _characters.AsSInt32(0);     
	// vf TotalReviewPages ̏ꍇ
	}else if (qname == "TotalReviewPages") {
		// 擾 
		_customerReviews->totalReviewPages = _characters.AsSInt32(0);    
	// vf Rating ̏ꍇ
	}else if (qname == "Rating") {
		// 擾 
		_review->rating = _characters.AsSInt32(0);    	
	// vf HelpfulVotes ̏ꍇ
	}else if (qname == "HelpfulVotes") {
		// 擾 
		_review->helpfulVotes = _characters.AsSInt32(0);  
	// vf CustomerId ̏ꍇ
	}else if (qname == "CustomerId") {
		// 擾 
		_review->customerId = _characters; 
	// vf TotalVotes ̏ꍇ
	}else if (qname == "TotalVotes") {
		// 擾 
		_review->totalVotes =  _characters.AsSInt32(0);   
	// vf Date ̏ꍇ
	}else if (qname == "Date") {
		// 擾 
		_review->date =  StringToDate(_characters);   
	// vf Summary ̏ꍇ
	}else if (qname == "Summary") {
		// 擾 
		_review->summary =  _characters;   
	// vf Content ̏ꍇ
	}else if (qname == "Content") {
		// 擾 
		_review->content =  _characters; 
		_customerReviews->reviews.Append(_review);

	}
}

// ȉ͋̃nh ( Cxg𖳎ꍇ` )
// vfɊ܂܂閳ɂł󔒕̒ʒm󂯎nh
Void SAXParser::IgnorableWhitespace(SFXAnsiStringConstRef string)
{
}
// ߂̒ʒm󂯎nh
Void SAXParser::ProcessingInstruction(SFXAnsiStringConstRef target, SFXAnsiStringConstRef data)
{
}
// ړ URI Oԃ}bsÕXR[v̊Jnʒm󂯎nh
Void SAXParser::StartPrefixMapping(SFXAnsiStringConstRef  prefix, SFXAnsiStringConstRef uri)
{
}
// ړ URI Oԃ}bsÕXR[v̏Iʒm󂯎nh
Void SAXParser::EndPrefixMapping(SFXAnsiStringConstRef  prefix)
{
}
// Rg̒ʒm󂯎nh
Void SAXParser::Comment(SFXAnsiStringConstRef string)
{
}
// CDATA ZNV̊Jnʒm󂯎nh
Void SAXParser::StartCDATA(Void)
{
}
// CDATA ZNV̏Iʒm󂯎nh
Void SAXParser::EndCDATA(Void)
{
}
// DTD 錾̊Jnʒm󂯎nh
Void SAXParser::StartDTD(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId)
{
}
// DTD 錾̏Iʒm󂯎nh
Void SAXParser::EndDTD(Void)
{
}
// ENTITY ̊Jnʒm󂯎nh
Void SAXParser::StartEntity(SFXAnsiStringConstRef name)
{
}
// ENTITY ̏Iʒm󂯎nh
Void SAXParser::EndEntity(SFXAnsiStringConstRef name)
{
}
// L@錾̒ʒm󂯎nh
Void SAXParser::NotationDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId)
{
}
// ߂̒ʒm󂯎nh
Void SAXParser::UnparsedEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId, SFXAnsiStringConstRef notationName)
{
}
// vf^錾̒ʒm󂯎nh
Void SAXParser::ElementDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef model)
{
}
// ATTLIST 錾̒ʒm󂯎nh
Void SAXParser::AttributeDecl(SFXAnsiStringConstRef ename, SFXAnsiStringConstRef aname, SFXAnsiStringConstRef type, SFXAnsiStringConstRef mode, SFXAnsiStringConstRef value)
{
}
//  ENTITY 錾̒ʒm󂯎nh
Void SAXParser::InternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value)
{
}
// O ENTITY 錾̒ʒm󂯎nh
Void SAXParser::ExternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId)
{
}
// G[̒ʒm󂯎nh
Void SAXParser::ErrorReport(SFCErrorConst error, SFXAnsiStringConstRef errInfo)
{
}

// wp[֐( t^ɕύX )
SFXDate SAXParser::StringToDate(SFXAnsiStringConstRef string)
{
    SFXDate ret(0);

    // Nݒ肷
    if (string.GetLength() >= 10) {
        ret.SetDate(static_cast<SInt16>(string.Substring(0, 4).AsUInt32()),
                    static_cast<SInt16>(string.Substring(5, 7).AsUInt32()),
                    static_cast<SInt16>(string.Substring(8, 10).AsUInt32()));
    }
    else if (string.GetLength() >= 7) {
        ret.SetDate(static_cast<SInt16>(string.Substring(0, 4).AsUInt32()),
                    static_cast<SInt16>(string.Substring(5, 7).AsUInt32()), 1);
    }
    return ret;
}
