//
//      SAXParser.hpp
//
//      This source code was automatically
//      generated by SophiaFramework 4.1.
//

#ifndef __SAXPARSER_HPP
#define __SAXPARSER_HPP

#define TARGET_BUILD_DEBUG
#include <SophiaFramework.hpp>

SFMTYPEDEFSTRUCT(ItemAttributesRec)
struct ItemAttributesRec {
	SFXAnsiString binding;
	SFXProperty creator;
	SInt32 amount;
	SFXAnsiString currencyCode;
	SFXAnsiString formattedPrice;
	SInt32 numberOfPages;
	SInt32 packageDimensionsLength;
	SInt32 packageDimensionsWidth;
	SFXAnsiString productGroup;
	SFXDate publicationDate;
	SFXAnsiString publisher;
};


SFMTYPEDEFSTRUCT(ImageUrlRec)
struct ImageUrlRec {
	SFXAnsiString smallImageURL;
	SInt32 smallImageHeight;
	SInt32 smallImageWidth;
	SFXAnsiString mediumImageURL;
	SInt32 mediumImageHeight;
	SInt32 mediumImageWidth;
	SFXAnsiString largeImageURL;
	SInt32 largeImageHeight;
	SInt32 largeImageWidth;
};

SFMTYPEDEFSTRUCT(OfferSummaryRec)
struct OfferSummaryRec {
	SInt32 lowestNewPrice;
	SFXAnsiString currencyCode;
	SFXAnsiString formattedPrice;
	SInt32 totalNew;
	SInt32 totalUsed;
	SInt32 totalCollectible;
	SInt32 totalRefurbished;
};

SFMTYPEDEFSTRUCT(OfferRec)
struct OfferRec {
	SFXAnsiString merchantId;
	SFXAnsiString condition;
	SFXAnsiString offerListingId;
	SInt32 amount;
	SFXAnsiString CurrencyCode;
	SFXAnsiString formattedPrice;
};

SFMTYPEDEFSTRUCT(OffersRec)
struct OffersRec {
	SInt32 totalOffers;
	SInt32 totalOfferspages;
	SFXArray<OfferRecPtr> offers;
};

SFMTYPEDEFSTRUCT(ReviewRec)
struct ReviewRec {
	SFXAnsiString asin;
	SInt32 rating;
	SInt32 helpfulVotes;
	SFXAnsiString customerId;
	SInt32 totalVotes;
	SFXDate date;
	SFXAnsiString summary;
	SFXAnsiString content;
};

SFMTYPEDEFSTRUCT(CustomerReviewsRec)
struct CustomerReviewsRec {
	SInt32 avarageRating;
	SInt32 totalReviews;
	SInt32 totalReviewPages;
	SFXArray<ReviewRecPtr> reviews;
};

SFMTYPEDEFSTRUCT(SimilarProductRec)
struct SimilarProductRec {
	SFXAnsiString asin;
	SFXAnsiString title;
};

SFMTYPEDEFSTRUCT(SimilarProductsRec)
struct SimilarProductsRec {
	SFXArray<SimilarProductRecPtr> similarProducts;
};
  
SFMTYPEDEFSTRUCT(BrowserNodesRec)
struct BrowserNodesRec {
	SFXAnsiString dummy;
	// Not yet implimentation.
};

SFMTYPEDEFSTRUCT(ListmaniaListsRec)
struct ListmaniaListsRec {
	SFXAnsiString dummy;
	// Not yet implimentation.
};


SFMTYPEDEFCLASS(SAXParser)
class SAXParser : public SFXXMLDefaultHandler {

public:
    explicit SAXParser(Void);
    virtual ~SAXParser(Void);

	SFXAnsiStringConstRef GetAsin(Void) { return _asin; }
    SFXAnsiStringConstRef GetDetailPageURL(Void) { return _detailPageURL; }
    SInt32 GetSalesRank(Void) { return _salesRank; }
    SFXAnsiStringConstRef GetTitle(Void) { return _title; }
	Bool GetXMLerror(Void) { return _xmlerrorflg; }

    ItemAttributesRecConstPtr GetItemAttributes(Void) { return _itemAttributes; }
    ImageUrlRecConstPtr GetImageUrl(Void) { return _imageUrl; }
    OfferSummaryRecConstPtr GetOfferSummary(Void) { return _offerSummary; }
    OffersRecConstPtr GetOffers(Void) { return _offers; }
    CustomerReviewsRecConstPtr GetCustomerReviews(Void) { return _customerReviews; }
    SimilarProductsRecConstPtr GetSimilarProducts(Void) { return _similarProducts; }
    BrowserNodesRecConstPtr GetBrowserNodes(Void) { return _browserNodes; }
    ListmaniaListsRecConstPtr GetListmaniaLists(Void) { return _listmaniaLists; }

	Void SetParseItemAttributes(Bool param) { _isParseItemAttributes = param; }
    Void SetParseImageUrl(Bool param) { _isParseImageUrl = param; }
    Void SetParseOfferSummary(Bool param) { _isParseOfferSummary = param; }
    Void SetParseOffers(Bool param) { _isParseOffers = param; }
    Void SetParseCustomerReviews(Bool param) { _isParseCustomerReviews = param; }
    Void SetParseSimilarProducts(Bool param) { _isParseSimilarProducts = param; }
    Void SetParseBrowserNodes(Bool param) { _isParseBrowserNodes = param; }
    Void SetParseListmaniaLists(Bool param) { _isParseListmaniaLists = param; }


public:
    // interface for ContentHandler
    virtual Void Characters(SFXAnsiStringConstRef string, BoolConst cdataSection = true);
    virtual Void EndDocument(Void);
    virtual Void EndElement(SFXAnsiStringConstRef uri = "", SFXAnsiStringConstRef localname = "", SFXAnsiStringConstRef qname = "");
    virtual Void StartDocument(Void);
    virtual Void StartElement(SFXAnsiStringConstRef uri, SFXAnsiStringConstRef localname, SFXAnsiStringConstRef qname, SFXXMLGrammar::XMLAttrListConstRef attrList);
    virtual Void IgnorableWhitespace(SFXAnsiStringConstRef string);
    virtual Void ProcessingInstruction(SFXAnsiStringConstRef target, SFXAnsiStringConstRef data);
    virtual Void EndPrefixMapping(SFXAnsiStringConstRef prefix);
    virtual Void StartPrefixMapping(SFXAnsiStringConstRef prefix, SFXAnsiStringConstRef uri);

    // interface for LexicalHandler
    virtual Void Comment(SFXAnsiStringConstRef string);
    virtual Void EndCDATA(Void);
    virtual Void EndDTD(Void);
    virtual Void EndEntity(SFXAnsiStringConstRef name);
    virtual Void StartCDATA(Void);
    virtual Void StartDTD(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);
    virtual Void StartEntity(SFXAnsiStringConstRef name);

    // interface for DTDHandler
    virtual Void NotationDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);
    virtual Void UnparsedEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId, SFXAnsiStringConstRef notationName);

    // interface for DeclHandler
    virtual Void ElementDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef model);
    virtual Void AttributeDecl(SFXAnsiStringConstRef ename, SFXAnsiStringConstRef aname, SFXAnsiStringConstRef type, SFXAnsiStringConstRef mode, SFXAnsiStringConstRef value);
    virtual Void InternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef value);
    virtual Void ExternalEntityDecl(SFXAnsiStringConstRef name, SFXAnsiStringConstRef publicId, SFXAnsiStringConstRef systemId);

    // others functions
    virtual Void ErrorReport(SFCErrorConst error, SFXAnsiStringConstRef errInfo); // bsC񍆂͕sx

	SFXDate StringToDate(SFXAnsiStringConstRef string);
	Void Clear(Void);

private:
	// ItemAttributes ̃^Ỏ͂邩ǂ
    Bool _isParseItemAttributes;
    // SmallImage ̃^Ỏ͂邩ǂ
    Bool _isParseImageUrl;
    Bool _isParseOfferSummary;
    Bool _isParseOffers;
    Bool _isParseCustomerReviews;
    Bool _isParseSimilarProducts;
    Bool _isParseBrowserNodes;
    Bool _isParseListmaniaLists;

	enum KindOfImage {NOTHING, SMALL, MEDIUM, LARGE};
	KindOfImage _kind;

	Bool _packageDimensionsflg;
	Bool _similarProductflg;
	Bool _itemflg;
	Bool _itemAttributesflg;
	Bool _characterGetflg;
	Bool _xmlerrorflg;


	SFXAnsiString _characters, _values;
	SFXAnsiString _asin;
    SFXAnsiString _detailPageURL;
    SInt32 _salesRank;
    SFXAnsiString _title;
	SFXSOAPRPC _rpc;

	// ߖ̂߃|C^ƂĕێB
    ItemAttributesRecPtr _itemAttributes;
    ImageUrlRecPtr _imageUrl;
    OfferSummaryRecPtr _offerSummary;
    OffersRecPtr _offers;
    CustomerReviewsRecPtr _customerReviews;
    SimilarProductsRecPtr _similarProducts;
	SimilarProductRecPtr _similarProduct;
    BrowserNodesRecPtr _browserNodes;
    ListmaniaListsRecPtr _listmaniaLists;
	ReviewRecPtr _review;
	
};

#endif // __SAXPARSER_HPP //
